=== debian/changelog ===
julius (1.7.0+dfsg-3) unstable; urgency=medium

  [ Antoine Le Gonidec ]
  * Update Uploader email.
  * Bump Standards-Version to 4.7.2.

  [ Sébastien Noel ]
  * Write saves and settings to XDG_DATA_HOME.

 -- Antoine Le Gonidec <debian@vv221.fr>  Mon, 17 Mar 2025 18:27:27 +0100

julius (1.7.0+dfsg-2) unstable; urgency=medium

  [ Patrice Duroux ]
  * Fix the team e-mail set as Maintainer.

  [ Alexandre Detiste ]
  * Clean up debian/rules.

 -- Antoine Le Gonidec <debian@dotslashplay.it>  Sun, 23 Feb 2025 16:12:03 +0100

julius (1.7.0+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #975380)

 -- Antoine Le Gonidec <debian@dotslashplay.it>  Sun, 24 Nov 2024 19:52:46 +0100
