=== debian/control ===
Source: julius
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Antoine Le Gonidec <debian@vv221.fr>
Homepage: https://github.com/bvschaik/julius
Vcs-Browser: https://salsa.debian.org/games-team/julius
Vcs-Git: https://salsa.debian.org/games-team/julius.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, libsdl2-dev, libsdl2-mixer-dev, libpng-dev

Package: julius
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-tk | zenity | kdialog
Description: Re-implementation of the Caesar III engine
 Julius is a fully working open-source version of Caesar 3, with the same logic
 as the original, but with some UI enhancements, that is able to be played on
 multiple platforms. The same logic means that the saved games are 100%
 compatible, and any gameplay bugs present in the original Caesar 3 game will
 also be present in Julius. It is meant as a drop-in replacement for Caesar 3,
 with the same look and feel, so there will be no major UI changes. UI
 enhancements for Julius include:
 .
  - Support for widescreen resolutions
  - Windowed mode support for 32-bit desktops
  - Several small in-game quality of life improvements
 .
 Julius requires the original assets (graphics, sounds, etc) from Caesar 3 to
 run. It optionally supports the high-quality MP3 files once provided on the
 Sierra website.
