=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%julius-$1.tar.gz%" \
    https://github.com/bvschaik/julius/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
