=== debian/changelog ===
julius (1.8.0+dfsg-2) unstable; urgency=medium

  * Drop obsolete field Rules-Requires-Root.
  * Drop obsolete field Priority.
  * Update debian/watch to version 5.
  * Add augustus-game to Suggests.
  * Add a mention of Augustus in the package description.
  * Fix build failure with CMake 4.
    (Closes: #1113668)

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 19 Nov 2025 00:47:36 +0100

julius (1.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop git-buildpackage configuration.
  * Update uploader e-mail.
  * Update XDG support patch to apply on current usptream codebase.
  * Update upstream metadata.

 -- Antoine Le Gonidec <vv221@debian.org>  Sun, 10 Aug 2025 19:47:29 +0200
