=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: julius
 Section: contrib/games
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Antoine Le Gonidec <debian@vv221.fr>
+Uploaders:
+ Antoine Le Gonidec <vv221@debian.org>,
 Homepage: https://github.com/bvschaik/julius
 Vcs-Browser: https://salsa.debian.org/games-team/julius
 Vcs-Git: https://salsa.debian.org/games-team/julius.git
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13), cmake, libsdl2-dev, libsdl2-mixer-dev, libpng-dev
 
 Package: julius
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-tk | zenity | kdialog
+Suggests: augustus-game
 Description: Re-implementation of the Caesar III engine
  Julius is a fully working open-source version of Caesar 3, with the same logic
  as the original, but with some UI enhancements, that is able to be played on
@@ -30,3 +30,7 @@
  Julius requires the original assets (graphics, sounds, etc) from Caesar 3 to
  run. It optionally supports the high-quality MP3 files once provided on the
  Sierra website.
+ .
+ If you would like to benefit from gameplay changes modernising the game
+ experience, you should install Augustus (package augustus-game) instead of
+ Julius.
