=== debian/watch ===
Version: 5

Template: Github
Owner: bvschaik
Project: julius
Dversion-Mangle: s/\+dfsg\d*$//
Repacksuffix: +dfsg
